(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('@triangular/bootstrap-icons', ['exports', '@angular/core', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.triangular = global.triangular || {}, global.triangular['bootstrap-icons'] = {}), global.ng.core, global.ng.common));
}(this, (function (exports, i0, common) { 'use strict';

    var BootstrapIconsRegistry = /** @class */ (function () {
        function BootstrapIconsRegistry() {
            this.registry = new Map();
        }
        BootstrapIconsRegistry.prototype.registerIcons = function (icons) {
            var _this = this;
            icons.forEach(function (icon) { return _this.registry.set(icon.name, icon.data); });
        };
        BootstrapIconsRegistry.prototype.getIcon = function (iconName) {
            if (!this.registry.has(iconName)) {
                console.warn("We could not find the dinosaur Icon with the name " + iconName + ", did you add it to the Icon registry?");
            }
            return this.registry.get(iconName);
        };
        return BootstrapIconsRegistry;
    }());
    BootstrapIconsRegistry.ɵprov = i0.ɵɵdefineInjectable({ factory: function BootstrapIconsRegistry_Factory() { return new BootstrapIconsRegistry(); }, token: BootstrapIconsRegistry, providedIn: "root" });
    BootstrapIconsRegistry.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];

    var BootstrapIconComponent = /** @class */ (function () {
        function BootstrapIconComponent(element, iconsRegistry, document) {
            this.element = element;
            this.iconsRegistry = iconsRegistry;
            this.document = document;
        }
        Object.defineProperty(BootstrapIconComponent.prototype, "name", {
            set: function (iconName) {
                if (this.svgIcon) {
                    this.element.nativeElement.removeChild(this.svgIcon);
                }
                var svgData = this.iconsRegistry.getIcon(iconName);
                if (svgData) {
                    this.svgIcon = this.svgElementFromString(svgData);
                    this.element.nativeElement.appendChild(this.svgIcon);
                }
            },
            enumerable: false,
            configurable: true
        });
        BootstrapIconComponent.prototype.svgElementFromString = function (svgContent) {
            var div = this.document.createElement('DIV');
            if (div instanceof HTMLElement) {
                div.innerHTML = svgContent;
                return div.querySelector('svg') || this.document.createElementNS('http://www.w3.org/2000/svg', 'path');
            }
        };
        return BootstrapIconComponent;
    }());
    BootstrapIconComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'bootstrap-icon',
                    template: "<ng-content></ng-content>",
                    encapsulation: i0.ViewEncapsulation.None,
                    changeDetection: i0.ChangeDetectionStrategy.OnPush
                },] }
    ];
    BootstrapIconComponent.ctorParameters = function () { return [
        { type: i0.ElementRef },
        { type: BootstrapIconsRegistry },
        { type: undefined, decorators: [{ type: i0.Optional }, { type: i0.Inject, args: [common.DOCUMENT,] }] }
    ]; };
    BootstrapIconComponent.propDecorators = {
        name: [{ type: i0.Input }]
    };

    var BootstrapIconsModule = /** @class */ (function () {
        function BootstrapIconsModule() {
        }
        BootstrapIconsModule.forRoot = function () {
            return {
                ngModule: BootstrapIconsModule,
                providers: [
                    BootstrapIconsRegistry,
                ],
            };
        };
        return BootstrapIconsModule;
    }());
    BootstrapIconsModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [BootstrapIconComponent],
                    imports: [],
                    exports: [BootstrapIconComponent]
                },] }
    ];

    /*
     * Public API Surface of the icons lib
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.BootstrapIconComponent = BootstrapIconComponent;
    exports.BootstrapIconsModule = BootstrapIconsModule;
    exports.BootstrapIconsRegistry = BootstrapIconsRegistry;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=triangular-bootstrap-icons.umd.js.map
